import { Compiler, Plugin } from 'webpack';
import { BabelTarget } from './babel.target';
/**
 * @internalapi
 */
export declare class TargetingPlugin implements Plugin {
    private targets;
    private exclude;
    private babelLoaderPath;
    private multiTargetLoaderPath;
    private babelLoaders;
    private remainingTargets;
    private readonly doNotTarget;
    constructor(targets: BabelTarget[], exclude: RegExp[], doNotTarget: RegExp[]);
    apply(compiler: Compiler): void;
    private getBlindTarget;
    targetLazyModules(resolveContext: any): Promise<any>;
    targetModule(module: any): void;
    private targetDependency;
    targetDependencies(babelTarget: BabelTarget, context: any): void;
    addBabelLoaders(resolveContext: any): Promise<void>;
    isTargetedRequest(request: string): boolean;
    isTargetedRequestContext(requestContext: any): boolean;
    isTranspiledRequest(resolveContext: any): boolean;
    getTargetFromContext(context: any): BabelTarget;
    private getTargetedBabelLoader;
    private replaceLoader;
    static readonly loader: string;
}
